<?php
/**
 * @license GPL-2.0-or-later
 *
 * Modified using Strauss.
 * @see https://github.com/BrianHenryIE/strauss
 */ declare(strict_types=1);

namespace RCP\LiquidWeb\LicensingApiClient;

use RCP\LiquidWeb\LicensingApiClient\Http\ApiVersion;
use RCP\LiquidWeb\LicensingApiClient\Http\AuthContext;
use RCP\LiquidWeb\LicensingApiClient\Http\AuthState;
use RCP\LiquidWeb\LicensingApiClient\Http\Factories\ApiUriFactory;
use RCP\LiquidWeb\LicensingApiClient\Http\Factories\ResponseExceptionFactory;
use RCP\LiquidWeb\LicensingApiClient\Http\JsonDecoder;
use RCP\LiquidWeb\LicensingApiClient\Http\RequestBuilder;
use RCP\LiquidWeb\LicensingApiClient\Http\RequestExecutor;
use RCP\LiquidWeb\LicensingApiClient\Http\RequestHeaderCollection;
use RCP\LiquidWeb\LicensingApiClient\Resources\Credit\CreditsLedgerResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\Credit\CreditsPoolsResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\Credit\CreditsQuotasResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\Credit\CreditsResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\EntitlementsResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\LicensesResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\ProductsResource;
use RCP\LiquidWeb\LicensingApiClient\Resources\TokensResource;
use RCP\Psr\Http\Client\ClientInterface as HttpClient;
use RCP\Psr\Http\Message\RequestFactoryInterface;
use RCP\Psr\Http\Message\StreamFactoryInterface;

/**
 * Builds a fully-wired API client from the transport dependencies.
 *
 * Use this if your application is not using a container to build dependencies.
 */
final class ApiBuilder
{
	private HttpClient $httpClient;

	private RequestFactoryInterface $requestFactory;

	private StreamFactoryInterface $streamFactory;

	private Config $config;

	public function __construct(
		HttpClient $httpClient,
		RequestFactoryInterface $requestFactory,
		StreamFactoryInterface $streamFactory,
		Config $config
	) {
		$this->httpClient     = $httpClient;
		$this->requestFactory = $requestFactory;
		$this->streamFactory  = $streamFactory;
		$this->config         = $config;
	}

	public function build(): Api {
		$authState               = new AuthState(new AuthContext(), $this->config->configuredToken);
		$requestHeaderCollection = new RequestHeaderCollection();
		$apiUriFactory           = new ApiUriFactory($this->config, ApiVersion::default());
		$requestExecutor         = $this->buildRequestExecutor();
		$creditsPools            = new CreditsPoolsResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection);
		$creditsQuotas           = new CreditsQuotasResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection);
		$creditsLedger           = new CreditsLedgerResource(
			$requestExecutor,
			$apiUriFactory,
			$authState,
			$requestHeaderCollection
		);

		return new Api(
			$authState,
			$requestHeaderCollection,
			new LicensesResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection),
			new ProductsResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection),
			new CreditsResource(
				$requestExecutor,
				$apiUriFactory,
				$authState,
				$requestHeaderCollection,
				$creditsPools,
				$creditsQuotas,
				$creditsLedger
			),
			new EntitlementsResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection),
			new TokensResource($requestExecutor, $apiUriFactory, $authState, $requestHeaderCollection)
		);
	}

	private function buildRequestExecutor(): RequestExecutor {
		$jsonDecoder = new JsonDecoder();

		return new RequestExecutor(
			$this->httpClient,
			new RequestBuilder(
				$this->requestFactory,
				$this->streamFactory
			),
			$jsonDecoder,
			new ResponseExceptionFactory($jsonDecoder)
		);
	}
}
